' ################
' # FTP protocol #
' ################
label FTPEnd

' FTP MESSAGES
dim MSG_RESTART_MARKER_REPLY$              ,MSG_SERVICE_READY_IN_X_MINUTES$        ,MSG_DC_OPEN_TRANSFER_STARTING$
dim MSG_OPEN_DC$                           ,MSG_DONE_CMD_OK$                       ,MSG_DONE_CMD_SYNTAX_NOT_IMPLEMENTED$
dim MSG_DONE_SYS_HELP_ANSWER$              ,MSG_DONE_FOLDER_STATE$                 ,MSG_DONE_FILE_STATE$
dim MSG_DONE_HELP_MESSAGE$                 ,MSG_DONE_SYSTEM_TYPE$                  ,MSG_DONE_READY_FOR_NEW_USER$
dim MSG_DONE_CLOSING_CC$                   ,MSG_DONE_DC_OPEN_NO_TRANFER$           ,MSG_DONE_TRANFER_OK$
dim MSG_DONE_ENTERING_PASSIVE_MODE$        ,MSG_DONE_USER_LOGGED_IN$               ,MSG_DONE_FILE_ACTION$
dim MSG_DONE_PATH$                         ,MSG_NEED_PASSWORD$                     ,MSG_NEED_ACCOUNT$
dim MSG_NEED_FURTHER_INFO$                 ,MSG_ERROR_SERVICE_NOT_AVIABLE_CLOSE_CC$,MSG_ERROR_CANT_OPEN_DC$
dim MSG_ERROR_DC_CLOSED_TRANFER_ABORTED$   ,MSG_ERROR_REQ_FILE_ACTION_UNAVIABLE$   ,MSG_ERROR_REQ_ACTION_LOCAL_ERROR$
dim MSG_ERROR_REQ_ACTION_OUTOF_MEMORY$     ,MSG_ABORTED_CMD_SYSNTAX_ERROR$         ,MSG_ABORTED_PAR_SYSNTAX_ERROR$
dim MSG_ABORTED_CMD_NOT_IMPLEMENTED$       ,MSG_ABORTED_BAD_CMD_SEQ$               ,MSG_ABORTED_CMD_PAR_NOT_IMPLEMENTED$
dim MSG_ABORTED_NOT_LOGGED_IN$             ,MSG_ABORTED_NEED_ACCOUNT_FOR_STORING$  ,MSG_ABORTED_REQ_FILE_UNAVIABLE$
dim MSG_ABORTED_REQ_ABORTED_UNKNOW_TYPE$   ,MSG_ABORTED_REQ_ABORTED_OUT_OF_STORAGE$,MSG_ABORTED_FILE_NAME_NOT_ALLOWED$

' FTP COMMANDS
dim CMD_ABORT$           ,CMD_ACCOUNT$   ,CMD_ALLOCATE$    ,CMD_APPEND$     ,CMD_CHANGE_DIR_UP$
dim CMD_CHANGE_WORK_DIR$ ,CMD_DELET_FILE$,CMD_GET_HELP$    ,CMD_GET_LIST$   ,CMD_MAKE_DIR$
dim CMD_GET_MLSD$        ,CMD_SET_MODE$  ,CMD_GET_NLST$    ,CMD_DO_NOOP$    ,CMD_PASSWORD$
dim CMD_PASSIVE$         ,CMD_SET_PORT$  ,CMD_GET_WORK_DIR$,CMD_QUIT$       ,CMD_RESTARD_CC$
dim CMD_RESTARD_TRANSFER$,CMD_GET_FILE$  ,CMD_DELETE_DIR$  ,CMD_RENAME_FROM$,CMD_RENAME_TO$
dim CMD_GET_SERVER_INFO$ ,CMD_MOUNT$     ,CMD_GET_STATUS$  ,CMD_STORE_FILE$ ,CMD_STORE_UNIQUE$
dim CMD_SET_STRUCTURE$   ,CMD_GET_SYSTEM$,CMD_SET_TYPE$    ,CMD_USER$       ,CMD_GET_FEAT$

' 1xx = ok task in work
MSG_RESTART_MARKER_REPLY$               = "110"
MSG_SERVICE_READY_IN_X_MINUTES$         = "120"
MSG_DC_OPEN_TRANSFER_STARTING$          = "125" : ' DC = data channel
MSG_OPEN_DC$                            = "150"
' 2xx = ok task done
MSG_DONE_CMD_OK$                        = "200" : ' (syntax) CMD = command
MSG_DONE_CMD_SYNTAX_NOT_IMPLEMENTED$    = "202" : ' (syntax)
MSG_DONE_SYS_HELP_ANSWER$               = "211" : ' (info) SYS = system
MSG_DONE_FOLDER_STATE$                  = "212" : ' (info)
MSG_DONE_FILE_STATE$                    = "213" : ' (info)
MSG_DONE_HELP_MESSAGE$                  = "214" : ' (info)
MSG_DONE_SYSTEM_TYPE$                   = "215" : ' (info)
MSG_DONE_READY_FOR_NEW_USER$            = "220" : ' (connection)
MSG_DONE_CLOSING_CC$                    = "221" : ' (connection) CC = control channel
MSG_DONE_DC_OPEN_NO_TRANFER$            = "225" : ' (connection)
MSG_DONE_TRANFER_OK$                    = "226" : ' (connection)
MSG_DONE_ENTERING_PASSIVE_MODE$         = "227" : ' (connection)
MSG_DONE_USER_LOGGED_IN$                = "230" : ' (account)
MSG_DONE_FILE_ACTION$                   = "250" : ' (server)
MSG_DONE_PATH$                          = "257" : ' (server)
' 3xx = ok but need more infos
MSG_NEED_PASSWORD$                      = "331" : ' (account)
MSG_NEED_ACCOUNT$                       = "332" : ' (account)
MSG_NEED_FURTHER_INFO$                  = "350" : ' (server) INFO = information
' 4xx = error
MSG_ERROR_SERVICE_NOT_AVIABLE_CLOSE_CC$ = "421" : ' (connection)
MSG_ERROR_CANT_OPEN_DC$                 = "425" : ' (connection)
MSG_ERROR_DC_CLOSED_TRANFER_ABORTED$    = "426" : ' (connection)
MSG_ERROR_REQ_FILE_ACTION_UNAVIABLE$    = "450" : ' (server) REQ = requested
MSG_ERROR_REQ_ACTION_LOCAL_ERROR$       = "451" : ' (server)
MSG_ERROR_REQ_ACTION_OUTOF_MEMORY$      = "452" : ' (server)
' 5xx = error aborted
MSG_ABORTED_CMD_SYSNTAX_ERROR$          = "500" : ' (syntax)
MSG_ABORTED_PAR_SYSNTAX_ERROR$          = "501" : ' (syntax) PAR = parameter
MSG_ABORTED_CMD_NOT_IMPLEMENTED$        = "502" : ' (syntax)
MSG_ABORTED_BAD_CMD_SEQ$                = "503" : ' (syntax) SEQ = sequence
MSG_ABORTED_CMD_PAR_NOT_IMPLEMENTED$    = "504" : ' (syntax)
MSG_ABORTED_NOT_LOGGED_IN$              = "530" : ' (account)
MSG_ABORTED_NEED_ACCOUNT_FOR_STORING$   = "532" : ' (account)
MSG_ABORTED_REQ_FILE_UNAVIABLE$         = "550" : ' (server)
MSG_ABORTED_REQ_ABORTED_UNKNOW_TYPE$    = "551" : ' (server)
MSG_ABORTED_REQ_ABORTED_OUT_OF_STORAGE$ = "552" : ' (server)
MSG_ABORTED_FILE_NAME_NOT_ALLOWED$      = "553" : ' (server)

' FTP COMMANDS
CMD_ABORT$            = "ABOR" : ' abort last command (and close DC)
CMD_ACCOUNT$          = "ACCT" : ' extended user account
CMD_ALLOCATE$         = "ALLO" : ' allocate space for next file (+"####")
CMD_APPEND$           = "APPE" : ' append files (+"name")
CMD_CHANGE_DIR_UP$    = "CDUP" : ' change to parent directory  (one folder up ..)
CMD_CHANGE_WORK_DIR$  = "CWD"  : ' change work directory + PATH
CMD_DELET_FILE$       = "DELE" : ' delete file + PATH
CMD_GET_FEAT$         = "FEAT" : ' list all new FTP features
CMD_GET_HELP$         = "HELP" : ' print help
CMD_GET_LIST$         = "LIST" : ' receive list from folder [+ SP PATH]
CMD_MAKE_DIR$         = "MKD"  : ' create directory + PATH
CMD_GET_MLSD$         = "MLSD" : ' receive list from folder (new)
CMD_SET_MODE$         = "MODE" : ' set transfer mode  (+"S" = stream | +"B" = block | +"C" compressed)
CMD_GET_NLST$         = "NLST" : ' receive name list
CMD_DO_NOOP$          = "NOOP" : ' no operations
CMD_PASSWORD$         = "PASS" : ' tranfer user password + PASSWORD
CMD_PASSIVE$          = "PASV" : ' request for passive connection
CMD_SET_PORT$         = "PORT" : ' set port address + HI,LO
CMD_GET_WORK_DIR$     = "PWD"  : ' receive current directory name
CMD_QUIT$             = "QUIT" : ' disconnect control channel
CMD_RESTARD_CC$       = "REIN" : ' close control connection and restart
CMD_RESTARD_TRANSFER$ = "REST" : ' restard file transfer [+file pointer]
CMD_GET_FILE$         = "RETR" : ' receive file + SOURCE_PATH + TARGET_PATH
CMD_DELETE_DIR$       = "RMD"  : ' delete directory + PATH
CMD_RENAME_FROM$      = "RNFR" : ' old file name + PATH
CMD_RENAME_TO$        = "RNTO" : ' new file name + PATH
CMD_GET_SERVER_INFO$  = "SITE" : ' receive server information
CMD_MOUNT$            = "SMNT" : ' structure mount
CMD_GET_STATUS$       = "STAT" : ' receive current status
CMD_STORE_FILE$       = "STOR" : ' store file + PATH
CMD_STORE_UNIQUE$     = "STOU" : ' store file under unic name [+ PATH]
CMD_SET_STRUCTURE$    = "STRU" : ' file structure  +"F" = File | +"R" = Record | +"P" = Page
CMD_GET_SYSTEM$       = "SYST" : ' get server OS
CMD_SET_TYPE$         = "TYPE" : ' set type  +"A" = ASCII | +"E" = EBCDIC | +"C" = Carriage Control | +"I" = Image   [+"L" <byte size>]
CMD_USER$             = "USER" : ' transfer user name + USER

dim FTP_SERVER$,FTP_PORT%,FTP_USER$,FTP_PASSWORD$
dim FTP_DIR$,FTP_SOURCE$,FTP_TARGET$

dim FTP_TIMEOUT%,FTP_TIME%,FTP_CONNECTED%,FTP_LOGGEDIN%,FTP_OK%
dim FTP_C%,FTP_P%,FTP_I%,FTP_IP$,FTP_T$
dim FTP_1$,FTP_2$,FTP_3$,FTP_4$,FTP_L$,FTP_H$
dim FTP_MSG$,FTP_CMD$,FTP_BUFFER$,FTP_SIZE%,FTP_LEN%
dim FTP_FILESIZE%,FTP_BLOCKS%,FTP_DEMO%

dim FTP_CC% : ' ftp [c]ontol [c]hannel
dim FTP_DC% : ' ftp [d]ata [c]hannel

' FTP high level (public)
label FTPConnect,FTPDisconnect,FTPQuit
label FTPPWD,FTPCWD,FTPLIST,FTPMLSD,FTPNLST,FTPFEAT
label FTPSTOR,FTPSTOU,FTPRETR

' FTP low level (private)
label CC_WAITMSG,DC_WAITMSG
label DC_Open
label CC_DC_CMD,CC_CMD,DC_CMD

FTP_SIZE%   = 1024*4 : ' 4K (should be an multiply of 512)
FTP_BUFFER$ = string$(FTP_SIZE%," ")

goto FTPEnd

' receive string over data channel with timeout
DC_WAITMSG:
  TCP_SOCKET% = FTP_DC%
  FTP_LEN% = 0
  FTP_MSG$ = ""
  gosub TCPServerData
  while (TCP_RESULT% <> -1) and (FTP_TIMEOUT% > 0)
    wait 100
    gosub TCPServerData
    if TCP_RESULT% <> -1
      FTP_TIMEOUT% = FTP_TIMEOUT% - 100
      if FTP_TIMEOUT% < 0 then exit_while
    end_if
  end_while
  '  data aviable ?
  while TCP_RESULT% = -1
    TCP_ADR  = adr(FTP_BUFFER$)
    TCP_SIZE% = len(FTP_BUFFER$)
    gosub TCPReadString
    if TCP_RESULT% > 0
      FTP_MSG$ = FTP_MSG$ + left$(FTP_BUFFER$,TCP_RESULT%)
      FTP_LEN% = FTP_LEN% + TCP_RESULT%
    end_if
    gosub TCPServerData
  end_while
  return

' receive string over control channel with timeout
CC_WAITMSG:
  TCP_SOCKET% = FTP_CC%
  FTP_LEN% = 0
  FTP_MSG$ = ""
  FTP_T$=""
  gosub TCPServerData
  while (TCP_RESULT% <> -1) and (FTP_TIMEOUT% > 0)
    wait 100
    gosub TCPServerData
    if TCP_RESULT% <> -1
      FTP_TIMEOUT% = FTP_TIMEOUT%-100
      if FTP_TIMEOUT% < 0 then exit_while
    end_if
  end_while
  '  data aviable ?
  while TCP_RESULT% = -1
    TCP_ADR  = adr(FTP_BUFFER$)
    TCP_SIZE% = len(FTP_BUFFER$)
    gosub TCPReadString
    if TCP_RESULT% > 0
      FTP_MSG$ = FTP_MSG$ + left$(FTP_BUFFER$,TCP_RESULT%)
      FTP_LEN% = FTP_LEN% + TCP_RESULT%
    else
      exit_while
    end_if
    gosub TCPServerData
  end_while
  FTP_LEN%=len(FTP_MSG$)
  if FTP_LEN%>0
    FTP_T$ = FTP_MSG$:FTP_MSG$=""
    FTP_P%=0
    for FTP_I% = 1 to FTP_LEN%
      FTP_C% = asc(mid$(FTP_T$,FTP_I%,1))
      if (FTP_C%=13) or (FTP_C%=10) or (FTP_C%=9)
        if (FTP_C%=13)
          if FTP_P%=0
            FTP_MSG$ = FTP_MSG$ + "|":FTP_P%=1
          end_if
          FTP_MSG$ = FTP_MSG$ + "<CR>"
        else
          if (FTP_C%=10)
            if FTP_P%=0
              FTP_MSG$ = FTP_MSG$ + "|":FTP_P%=1
            end_if
            FTP_MSG$ = FTP_MSG$ + "<LF>"
          else
            if (FTP_C%= 9) then FTP_MSG$ = FTP_MSG$ + "<-->"
          end_if
        end_if
      else
        FTP_MSG$ = FTP_MSG$+chr$(FTP_C%)
      end_if
    next FTP_I%
    if MSG_LOG% <> 0 then item_add MSG_LOG%,"MSG: " + FTP_MSG$
  end_if
  return

CC_CMD:
  TCP_SOCKET% = FTP_CC%
  goto CC_DC_CMD

DC_CMD:
  TCP_SOCKET% = FTP_DC%
  goto CC_DC_CMD
  
' transmit ftp comand over [C]ontrol or [D]ata [C]hannel
CC_DC_CMD:
  if MSG_LOG%<>0
    if instr(FTP_CMD$,"PASS")<>0
      item_add MSG_LOG%,"CMD: PASS " + string$(len(FTP_CMD$)-4,"*") + "|<CR><LF>"
    else
      item_add MSG_LOG%,"CMD: " + FTP_CMD$ + "|<CR><LF>"
    end_if
  end_if
  if right$(FTP_CMD$,2) <> LINE_END$
    FTP_CMD$ = FTP_CMD$ + LINE_END$
  end_if
  TCP_ADR  = adr(FTP_CMD$)
  TCP_SIZE% = len(FTP_CMD$)
  gosub TCPWriteString
  FTP_LEN% = TCP_RESULT%
  if FTP_LEN%<>TCP_SIZE% then FTP_LEN%=0
  return
  
' open [D]ata [C]hannel
DC_Open:
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return

  ' go in passive data mode
  FTP_CMD$     = CMD_PASSIVE$ : gosub CC_Cmd
  FTP_TIMEOUT% = 5000         : gosub CC_WaitMsg
  if FTP_LEN%=0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in DC_Open timeout!"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  while left$(FTP_MSG$,3) = MSG_DONE_FILE_ACTION$
    FTP_TIMEOUT% = 5000 : gosub CC_WaitMsg
  end_while

  if left$(FTP_MSG$,3) <> MSG_DONE_ENTERING_PASSIVE_MODE$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in DC_Open can't go in passive mode! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  ' extract IP and port
  FTP_P%=1:FTP_1$="":FTP_2$="":FTP_3$="":FTP_4$="":FTP_H$="":FTP_L$=""
  while mid$(FTP_MSG$,FTP_P%,1)<>"(":                                      FTP_P%=FTP_P%+1:end_while:FTP_P%=FTP_P%+1
  while mid$(FTP_MSG$,FTP_P%,1)<>",":FTP_1$=FTP_1$+mid$(FTP_MSG$,FTP_P%,1):FTP_P%=FTP_P%+1:end_while:FTP_P%=FTP_P%+1
  while mid$(FTP_MSG$,FTP_P%,1)<>",":FTP_2$=FTP_2$+mid$(FTP_MSG$,FTP_P%,1):FTP_P%=FTP_P%+1:end_while:FTP_P%=FTP_P%+1
  while mid$(FTP_MSG$,FTP_P%,1)<>",":FTP_3$=FTP_3$+mid$(FTP_MSG$,FTP_P%,1):FTP_P%=FTP_P%+1:end_while:FTP_P%=FTP_P%+1
  while mid$(FTP_MSG$,FTP_P%,1)<>",":FTP_4$=FTP_4$+mid$(FTP_MSG$,FTP_P%,1):FTP_P%=FTP_P%+1:end_while:FTP_P%=FTP_P%+1
  while mid$(FTP_MSG$,FTP_P%,1)<>",":FTP_H$=FTP_H$+mid$(FTP_MSG$,FTP_P%,1):FTP_P%=FTP_P%+1:end_while:FTP_P%=FTP_P%+1
  while mid$(FTP_MSG$,FTP_P%,1)<>")":FTP_L$=FTP_L$+mid$(FTP_MSG$,FTP_P%,1):FTP_P%=FTP_P%+1:end_while
  FTP_IP$ = FTP_1$ + "." + FTP_2$ + "." + FTP_3$ + "." + FTP_4$
  TCP_PORT% = val(FTP_H$)*256 + val(FTP_L$)
  TCP_ADR  = adr(FTP_IP$)
  gosub TCPCreateClient
  if TCP_RESULT% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in DC_Open can't create data connection! >"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  FTP_DC% = TCP_RESULT%
  return
  
' ########################
' # public user commands #
' ########################
  
' create ftp connection and log in
' input: FTP_SERVER$, FTP_USER$, FTP_PASSWORD$
FTPConnect:
  if (FTP_CONNECTED%<>0) then FTPDisconnect
  FTP_TIME%      = 0
  FTP_OK%        = 0
  FTP_CONNECTED% = 0
  FTP_LOGGEDIN%  = 0
  if FTP_SERVER$   = "demo" 
  if FTP_USER$     = "demo" 
  if FTP_PASSWORD$ = "demo"
    FTP_DEMO% = 1
  else
    FTP_DEMO% = 0
  end_if
  end_if
  end_if

  ' create FTP client connection
  if FTP_DEMO%=1
     gosub TCPDemoServer
   else
    TCP_ADR = adr(FTP_SERVER$) : TCP_PORT% = 21 : gosub TCPCreateClient
  end_if
  if TCP_RESULT% = 0
    FTP_MSG$ = "ERROR: in FTPConnect can't connect to " + FTP_SERVER$ + " !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  FTP_CC%  = TCP_RESULT%
  FTP_CONNECTED% = 1
  
  ' get message from FTP server
  FTP_TIMEOUT% = 5000 : gosub CC_WAITMSG
  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in FTPConnect timeout!"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  ' is it the welcome message ?
  if left$(FTP_MSG$,3) <> MSG_DONE_READY_FOR_NEW_USER$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in FTPConnect no welcome message >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  ' some more welcome messages are possible
  while (FTP_LEN%>0) : ' and (left$(FTP_MSG$,3) = MSG_DONE_READY_FOR_NEW_USER$)
    FTP_TIMEOUT% = 1000 : gosub CC_WaitMsg
  end_while
  
  ' log in
  if FTP_DEMO%=1
    TCP_SOCKET% = FTP_CC% : gosub TCPDemoUser:FTP_LEN% = TCP_RESULT%
  else
    FTP_CMD$ = CMD_USER$ + " " + FTP_USER$: gosub CC_CMD
  end_if
  FTP_TIMEOUT% = 10000 : gosub CC_WAITMSG
  if FTP_LEN%=0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in FTPConnect 'USER' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  ' password needed ?
  if left$(FTP_MSG$,3)=MSG_NEED_PASSWORD$
    if FTP_DEMO%=1
      TCP_SOCKET% = FTP_CC% : gosub TCPDemoPassword : FTP_LEN% = TCP_RESULT%
    else
      FTP_CMD$ = CMD_PASSWORD$ + " " + FTP_PASSWORD$:gosub CC_CMD
    end_if
    FTP_TIMEOUT% = 10000 : gosub CC_WAITMSG
    if FTP_LEN%=0
      gosub FTPDisconnect
      FTP_MSG$ = "ERROR: in FTPConnect 'PASS' timeout !"
      if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
      return
    end_if
  end_if
  
  ' we are logged in ?
  if left$(FTP_MSG$,3)<>MSG_DONE_USER_LOGGED_IN$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in FTPConnect not logged in ! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  ' some more logged in messages are possible
  while (FTP_LEN%>0) : ' and (left$(FTP_MSG$,3) = MSG_DONE_USER_LOGGED_IN$)
    FTP_TIMEOUT% = 1000 : gosub CC_WAITMSG
  end_while
  
  FTP_LOGGEDIN%  = 1

  ' set FTP binary type
  FTP_CMD$     = CMD_SET_TYPE$ + " I" : gosub CC_CMD
  FTP_TIMEOUT% = 5000                 : gosub CC_WAITMSG
  if FTP_LEN%=0
    gosub FTPDisconnect
    TCPDeleteClient
    FTP_MSG$="ERROR: in FTPConnect SET_TYPE Timeout!"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  if left$(FTP_MSG$,3) <> MSG_DONE_CMD_OK$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: in FTPConnect 'TYPE' missing done message!>" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  FTP_MSG$ = "OK:"
  FTP_OK% = 1
  return

' FTP log out
FTPQUIT:
  if (FTP_CONNECTED%=0)
    FTP_LOGGEDIN% = 0
    return
  end_if

  if FTP_LOGGEDIN%<>0
    FTP_CMD$      = CMD_QUIT$ : gosub CC_CMD
    FTP_TIMEOUT%  = 2000      : gosub CC_WAITMSG
    while (FTP_LEN%>0) : ' and (left$(FTP_MSG$,3)=MSG_DONE_CLOSING_CC$)
      FTP_TIMEOUT%  = 1000 : gosub CC_WAITMSG
    end_while
    FTP_LOGGEDIN% = 0
  end_if
  
  FTP_MSG$ = "OK:"
  return
  
' FTP log out and disconnect
FTPDisconnect:
  ' data channel ?
  if FTP_DC% <> 0
    TCP_SOCKET% = FTP_DC% : gosub TCPDeleteclient
    FTP_DC% = 0
  end_if
  ' controll channel ?
  if FTP_CC% <> 0
    ' must send quit ?
    if FTP_LOGGEDIN% <> 0 then gosub FTPQUIT
    TCP_SOCKET% = FTP_CC% : gosub TCPDeleteClient
    FTP_CC% = 0
  end_if

  FTP_CONNECTED% = 0
  FTP_LOGGEDIN%  = 0
  if MSG_LOG% <> 0 then item_add MSG_LOG%,"MSG: disconnected"
  
  FTP_MSG$ = "OK:"
  return

' FTP [P]rint [W]ork [D]irectory
' output: FTP_DIR$
FTPPWD:
  FTP_TIME% = 0
  FTP_OK%   = 0
  FTP_DIR$  = ""
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return

  FTP_CMD$     = CMD_GET_WORK_DIR$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000              : gosub CC_WAITMSG
  
  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'PWD' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  if left$(FTP_MSG$,3) <> MSG_DONE_PATH$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'PWD' wrong answer ! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  

  ' copy work directory in FTP_DIR$
  FTP_P%   = instr (FTP_MSG$,chr$(34))
  FTP_MSG$ = right$(FTP_MSG$,len(FTP_MSG$)-FTP_P%)
  FTP_P%   = instr (FTP_MSG$,chr$(34))
  FTP_DIR$ = left$ (FTP_MSG$,FTP_P%-1)

  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return
  
' FTP [C]hange [W]ork [D]irectory
' input: FTP_DIR$
FTPCWD:
  FTP_TIME% = 0
  FTP_OK%   = 0
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return

  FTP_CMD$     = CMD_CHANGE_WORK_DIR$ + " " + FTP_DIR$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000                                  : gosub CC_WAITMSG

  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'CWD' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  if left$(FTP_MSG$,3) <> MSG_DONE_FILE_ACTION$
    FTP_MSG$ = "ERROR: 'CWD' wrong answer ! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  while FTP_LEN%>0
    FTP_TIMEOUT% = 1000 : gosub CC_WAITMSG
  end_while
  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return


' FTP get server [FEAT]ures
' output: FTP_MSG$
FTPFEAT:
  FTP_TIME%
  FTP_OK% = 0
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return

  FTP_CMD$ = CMD_GET_FEAT$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000      : gosub CC_WAITMSG
  if (FTP_LEN% = 0)
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'FEAT' timeout!"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  if left$(FTP_MSG$,3) <> MSG_DONE_SYS_HELP_ANSWER$
    FTP_MSG$ = "WARNING: 'FEAT' command not supported."
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  FTP_DIR$     = FTP_MSG$
  FTP_TIMEOUT% = 5000 : gosub CC_WAITMSG

  while FTP_LEN% > 0
    FTP_DIR$=FTP_DIR$+FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    FTP_TIMEOUT% = 1000 : gosub CC_WAITMSG
  end_while
  FTP_MSG$ = FTP_DIR$ : FTP_DIR$=""
  FTP_OK%  = 1
  return
  
' FTP get folder [LIST]ing in unix "ls" format
' output: FTP_DIR$
FTPLIST:
  FTP_TIME% = 0
  FTP_OK%   = 0
  FTP_DIR$  = ""
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return
  
  gosub DC_OPEN : if FTP_DC% = 0 then return

  FTP_CMD$     = CMD_GET_LIST$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000          : gosub CC_WAITMSG

  if (FTP_LEN% = 0)
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'LIST' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  if (left$(FTP_MSG$,3) <> MSG_OPEN_DC$)
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'LIST' data channel not open !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  FTP_TIMEOUT% = 5000 : gosub DC_WAITMSG
  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'LIST' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  FTP_DIR$     = FTP_MSG$
  ' close data channel
  TCP_SOCKET%  = FTP_DC% : gosub TCPDeleteClient
  FTP_TIMEOUT% = 1000    : gosub CC_WAITMSG

  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return
  
' get folder listing in modern format
FTPMLSD:
  FTP_TIME% = 0
  FTP_OK%   = 0
  FTP_DIR$  = ""
  
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return
  
  gosub DC_OPEN : if FTP_DC% = 0 then return

  FTP_CMD$     = CMD_GET_MLSD$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000          : gosub CC_WAITMSG
  if (FTP_LEN% = 0) or (left$(FTP_MSG$,3) <> MSG_OPEN_DC$)
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'MLSD' data channel not open !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  FTP_TIMEOUT% = 5000 : gosub DC_WAITMSG
  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'MLSD' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  FTP_DIR$ = FTP_MSG$
  TCP_SOCKET%  = FTP_DC% : gosub TCPDeleteClient
  FTP_TIMEOUT% = 1000    : gosub CC_WAITMSG
  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return
  
' FTP get [N]ame [L]i[ST]
' output: FTP_DIR$
FTPNLST:
  FTP_TIME% = 0
  FTP_OK%   = 0
  FTP_DIR$  = ""

  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return

  gosub DC_OPEN : if FTP_DC% = 0 then return

  FTP_CMD$     = CMD_GET_NLST$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000          : gosub CC_WAITMSG
  if (FTP_LEN% = 0) or (left$(FTP_MSG$,3) <> MSG_OPEN_DC$)
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'NLST' data channel not open !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  FTP_TIMEOUT% = 5000 : gosub DC_WAITMSG
  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'NLST' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  FTP_DIR$ = FTP_MSG$
  TCP_SOCKET%  = FTP_DC% : gosub TCPDeleteClient
  FTP_TIMEOUT% = 1000    : gosub CC_WAITMSG
  
  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return

' FTP [STOR]e FTP_SOURCE$ file as FTP_TARGET$ on server.
' input: FTP_SOURCE$,FTP_TARGET$
FTPSTOR:
  FTP_TIME% = 0
  FTP_OK%   = 0
  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return
  
  TCP_ADR = adr(FTP_SOURCE$) : gosub TCPFileExists
  if TCP_RESULT%<>-1
    FTP_MSG$ = "WARNING: 'STOR' '" + FTP_SOURCE$ + "' does not exists !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  gosub DC_OPEN : if FTP_DC% = 0 then return

  FTP_CMD$     = CMD_STORE_FILE$ + " " + FTP_TARGET$: gosub CC_CMD
  FTP_TIMEOUT% = 5000                               : gosub CC_WAITMSG

  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'STOR' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  if left$(FTP_MSG$,3) <> MSG_OPEN_DC$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'STOR' data chanel not open !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  TCP_SOCKET% = FTP_DC%
  
  ' open file and get size
  TCP_ADR = adr(FTP_SOURCE$)
  gosub TCPOpenFile
  gosub TCPFileLength
  FTP_FILESIZE% = TCP_RESULT%

  ' how many blocks ?
  FTP_BLOCKS% = FTP_FILESIZE% / FTP_SIZE%

  if MSG_LOG% <> 0 then item_add MSG_LOG%,"MSG: info 'STOR' '" + FTP_SOURCE$ + "' as '" + FTP_TARGET$ + "' " + str$(FTP_FILESIZE%) + " bytes."

        
  gosub TCPTime : FTP_TIME%=TCP_RESULT%
  
  ' send n blocks of FTP_SIZE% bytes
  if FTP_BLOCKS%>0
    TCP_ADR  = adr(FTP_BUFFER$)
    TCP_SIZE% = FTP_SIZE%
    for FTP_I% = 1 to FTP_BLOCKS%
      gosub TCPFileReadString
      gosub TCPWriteString
      FTP_FILESIZE% = FTP_FILESIZE% - FTP_SIZE%
    next FTP_I%
  end_if
  
  ' any rest ?
  if FTP_FILESIZE%>0
    TCP_ADR  = adr(FTP_BUFFER$)
    TCP_SIZE% = FTP_FILESIZE%
    gosub TCPFileReadString
    gosub TCPWriteString
  end_if
  gosub TCPTime : FTP_TIME% = TCP_RESULT%-FTP_TIME%
  
  ' close file
  gosub TCPCloseFile
  
  if MSG_LOG% <> 0
    FTP_FILESIZE% = FTP_FILESIZE% + FTP_BLOCKS% * FTP_SIZE%
    FTP_MSG$ = "MSG: 'STOR' " + str$(FTP_FILESIZE%) + " bytes transfered in " + str$(FTP_TIME%/1000.0) + " seconds"
    item_add MSG_LOG%,FTP_MSG$
  end_if

  ' close data channel
  TCP_SOCKET% = FTP_DC% : gosub TCPDeleteClient : FTP_DC% = 0
  
  ' get done message
  FTP_TIMEOUT% = 5000 : gosub CC_WAITMSG
  if FTP_LEN%=0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'STOR' timeout for transfer done message !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  if left$(FTP_MSG$,3) <> MSG_DONE_TRANFER_OK$
    FTP_MSG$ = "ERROR: 'STOR' missing transfer done message ! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return
  
' This command behaves like FTPSTOR except that the resultant file is to be created
' in the current server directory under a name unique to that directory.
' input:  FTP_SOURCE$
' output: FTP_TARGET$ (new unique name on server)
FTPSTOU:
  FTP_TIME%   = 0
  FTP_OK%     = 0
  FTP_TARGET$ = ""

  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return
  
  TCP_ADR = adr(FTP_SOURCE$) : gosub TCPFileExists
  if TCP_RESULT%<>-1
    FTP_MSG$ = "WARNING: 'STOU' '" + FTP_SOURCE$ + "' does not exists !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  gosub DC_OPEN : if FTP_DC% = 0 then return

  FTP_CMD$     = CMD_STORE_UNIQUE$ + " " + FTP_TARGET$: gosub CC_CMD
  FTP_TIMEOUT% = 5000                                 : gosub CC_WAITMSG

  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'STOU' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  if left$(FTP_MSG$,3) <> MSG_OPEN_DC$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'STOU' data channel not open !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  TCP_SOCKET% = FTP_DC%
  
  ' get unique filename
  FTP_P%   = instr(FTP_MSG$,":") : FTP_P%   = FTP_P%+1
  FTP_LEN% = instr(FTP_MSG$,"|") : FTP_LEN% = FTP_LEN%-1
  for FTP_I% = FTP_P% to FTP_LEN%
    FTP_C% = asc(mid$(FTP_MSG$,FTP_I%,1))
    if (FTP_C%=32) or (FTP_C%=13) or (FTP_C%=10)
    else
      FTP_TARGET$ = FTP_TARGET$ + chr$(FTP_C%)
    end_if
  next FTP_I%

  ' open file and get size
  TCP_ADR = adr(FTP_SOURCE$)
  gosub TCPOpenFile
  gosub TCPFileLength
  FTP_FILESIZE% = TCP_RESULT%

  ' how many blocks ?
  FTP_BLOCKS% = FTP_FILESIZE% / FTP_SIZE%

  if MSG_LOG% <> 0 then item_add MSG_LOG%,"MSG: info 'STOU' '" + FTP_SOURCE$ + "' as '" + FTP_TARGET$ + "' " + str$(FTP_FILESIZE%) + " bytes."

  gosub TCPTime : FTP_TIME% = TCP_RESULT%

  ' send n blocks of FTP_SIZE% bytes
  if FTP_BLOCKS%>0
    TCP_ADR  = adr(FTP_BUFFER$)
    TCP_SIZE% = FTP_SIZE%
    for FTP_I% = 1 to FTP_BLOCKS%
      gosub TCPFileReadString
      gosub TCPWriteString
      FTP_FILESIZE% = FTP_FILESIZE% - FTP_SIZE%
    next FTP_I%
  end_if

  ' any rest ?
  if FTP_FILESIZE%>0
    TCP_ADR  = adr(FTP_BUFFER$)
    TCP_SIZE% = FTP_FILESIZE%
    gosub TCPFileReadString
    gosub TCPWriteString
  end_if
  gosub TCPTime : FTP_TIME% = TCP_RESULT% - FTP_TIME%

  ' close file
  gosub TCPCloseFile

  if MSG_LOG% <> 0
    FTP_FILESIZE% = FTP_FILESIZE% + FTP_BLOCKS% * FTP_SIZE%
    FTP_MSG$ = "MSG: 'STOU' " + str$(FTP_FILESIZE%) + " bytes transfered in " + str$(FTP_TIME%/1000.0) + " seconds"
    item_add MSG_LOG%,FTP_MSG$
  end_if

  ' close data channel
  TCP_SOCKET% = FTP_DC% : gosub TCPDeleteClient : FTP_DC% = 0

  ' get done message
  FTP_TIMEOUT% = 5000 : gosub CC_WAITMSG
  if FTP_LEN%=0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'STOU' timeout for transfer done message !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  if left$(FTP_MSG$,3) <> MSG_DONE_TRANFER_OK$
    FTP_MSG$ = "ERROR: 'STOU' missing transfer done message ! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  
  FTP_MSG$ = "OK:"
  FTP_OK%  = 1
  return

' FTP [RETR]ieve file FTP_SOURCE$ from Server and save it as FTP_TARGET$
' input : FTP_SOURCE$ , FTP_TARGET$
' output: FTP_FILE_SIZE%
FTPRETR:
  FTP_TIME% = 0
  FTP_OK%   = 0

  if (FTP_CONNECTED%=0) or (FTP_LOGGEDIN%=0) then return

  ' open data channel
  gosub DC_OPEN : if FTP_DC% = 0 then return

  FTP_CMD$     = CMD_GET_FILE$ + " " + FTP_SOURCE$ : gosub CC_CMD
  FTP_TIMEOUT% = 5000                              : gosub CC_WAITMSG
  if FTP_LEN% = 0
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'RETR' timeout !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  if left$(FTP_MSG$,3) <> MSG_OPEN_DC$
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'RETR' data channel not open !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if

  
  FTP_FILESIZE% = 0
  ' create file
  TCP_ADR = adr(FTP_TARGET$)
  gosub TCPCreateFile
  if TCP_RESULT%<>-1
    gosub FTPDisconnect
    FTP_MSG$ = "ERROR: 'RETR' can't create '" + FTP_TARGET$ + "' !"
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    return
  end_if
  if MSG_LOG% <> 0
    item_add MSG_LOG%,"MSG: retrieve '" + FTP_SOURCE$ + "' save as '" + FTP_TARGET$ + "'"
  end_if
  gosub TCPTime : FTP_TIME% = TCP_RESULT%


  while FTP_OK%=0
    ' wait on data
    TCP_SOCKET% = FTP_DC%:gosub TCPServerData
    FTP_TIMEOUT% = 5000
    while (TCP_RESULT%<>-1) and (FTP_TIMEOUT%>0)
      wait 100:FTP_TIMEOUT%=FTP_TIMEOUT%-100
      gosub TCPServerData
    end_while
    ' data aviable
    if FTP_TIMEOUT%>0
      TCP_ADR  = adr(FTP_BUFFER$)
      TCP_SIZE% = FTP_SIZE%
      gosub TCPReadString
      if TCP_RESULT%>0
        TCP_SIZE% = TCP_RESULT%
        gosub TCPFileWriteString
        FTP_FILESIZE% = FTP_FILESIZE% + TCP_RESULT%
        if MSG_LOG% <> 0
          item_add MSG_LOG%,"got data " + str$(TCP_RESULT%)
        end_if
      end_if
    else
      ' no new data we are ready ?
      FTP_TIMEOUT% = 5000
      while FTP_TIMEOUT%>0 and instr(FTP_MSG$,MSG_DONE_TRANFER_OK$)=0
        gosub CC_WAITMSG
      end_while
      if instr(FTP_MSG$,MSG_DONE_TRANFER_OK$)>0
        FTP_OK%=1
      else
        ' we got a different message
        if FTP_LEN%>0
          FTP_OK%=2
        else
          if FTP_TIMEOUT%<=0 then FTP_OK%=3
        end_if
      end_if
    end_if
  end_while
  gosub TCPTime : FTP_TIME% = TCP_RESULT% - FTP_TIME%
  ' close file
  gosub TCPCloseFile
  ' close data channel
  TCP_SOCKET% = FTP_DC% : gosub TCPDeleteClient : FTP_DC% = 0

  if FTP_OK%=1 
    if MSG_LOG% <> 0
      FTP_MSG$ = "MSG: 'RETR' " + str$(FTP_FILESIZE%) + " bytes transfered in " + str$(FTP_TIME%/1000.0) + " seconds."
      item_add MSG_LOG%,FTP_MSG$
    end_if
    FTP_MSG$ = "OK:"
    return
  end_if

  if FTP_OK%=2
    FTP_MSG$ = "ERROR: 'RETR' missing transfer done message ! >" + FTP_MSG$
    if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
    FTP_OK% = 0
    return
  end_if

  FTP_OK%=0
  FTP_MSG$ = "ERROR: 'RETR' timeout !"
  if MSG_LOG% <> 0 then item_add MSG_LOG%,FTP_MSG$
  return
FTPEnd:
